<?php
/**
 * Plugin spxwbookmarket
 *
 * @package SPX
 * @version	
 * @date	02/04/2015
 * @author	JE-EVRARD
 **/


class spxwbookmarket extends plxPlugin {
	
	
	/**
	 * Constructeur de la classe
	 *
	 * @param	default_lang	langue par dfaut
	 * @return	stdio
	 * @author	JE-EVRARD
	 **/
	public function __construct($default_lang) {
		
		# Appel du constructeur de la classe plxPlugin (obligatoire)
		parent::__construct($default_lang);
		
		# droits pour accder  la page config.php du plugin
		$this->initconfiguration();
		
		$this->spxname="spxwbookmarket";
		
		# Dclarations des hooks
		if(!defined('PLX_ADMIN')) {
			//$this->addHook('ThemeEndHead', 'addCssLibrairy');
			//$this->addHook('ThemeEndBody', 'addJSlibrairy');
		}
		
		$this->addHook('plxMotorPreChauffageBegin', 'plxMotorPreChauffageBegin');
		$this->addHook('spxwbookmarket::getBookmarket', 'getBookmarketRequest');
		$this->addHook('spxwbookmarket::getBookmarketkeyword', 'getBookmarketkeywordRequest');
		
	}
	
	/**
	 * Mthode qui initialise les variables
	 *
	 * @author	JE-EVRARD
	 **/
	public function initconfiguration() {
		# VARIOUS PARAMS
		$this->setParam('spxdatas_widget', '1', 'string');
		$this->setParam('spxshortcodes_shortcode', '1', 'string');
	}
	
	/**
	 * Mthode a l'activation du plugin
	 *
	 * @author	JE-EVRARD
	 **/
	public function OnActivate() {
		
	}
	
	/**
	 * Mthode principale qui retourne le bookmarket
	 *
	 * @return	string // html menu;
	 * @author	JE-EVRARD
	 **/
	public function getBookmarketRequest($o) {
		$s='';
		$s.= $this->getRequestPrepare($o);
		return $s;
	}
	
	/**
	 * Mthode qui retourne le bookmarket et prepare la requete a spxdatas
	 *
	 * @return	string // html menu;
	 * @author	JE-EVRARD
	 **/
	public function getRequestPrepare($oatts) {
		
		$plxMotor = plxMotor::getInstance();
		
		$o= array();
		$o["table"]="spxwbookmarket";
		$o["format"]=$oatts["format"];
		$o["filter"]="actif=1";
		
		$tmp = $plxMotor->plxPlugins->aPlugins["spxdatas"];
		
		$o["out"]="html";
		$tmp2 = $tmp->getData($o);
		
		return $tmp2;
	}
	
	/**
	 * Mthode principale qui retourne le bookmarket avec keyword
	 *
	 * @return	string // html menu;
	 * @author	JE-EVRARD
	 **/
	public function getBookmarketkeywordRequest($o) {
		$s='';
		$s.= $this->getRequestkeywordPrepare($o);
		return $s;
	}
	
	/**
	 * Mthode qui retourne le bookmarket avec filtre keyword
	 *
	 * @return	string // html bookmarket keyword;
	 * @author	JE-EVRARD
	 **/
	public function getRequestkeywordPrepare($oatts) {
		
		/*-1)------------get keyword------------------*/
		$plxMotor = plxMotor::getInstance();
		
		$get = plxUtils::getGets();
		# redefine path_url (for home path_url="" redefine in hook plxMotorPreChauffageBegin)
		$path_url = $plxMotor->path_url;
		
		$cible = "";
		
		if($get AND preg_match('/tagbookmarket\/([a-z0-9-]+)/',$get,$capture)) {
			$cible = $capture[1];
			$path_url = $plxMotor->urlRewrite (str_replace('/tagbookmarket/'.$cible,'',$path_url));
		}
		
		/*-2)------------request to spxdatas----------*/
		
		/*-2.1)------------keyword--------------------*/
		$o= array();
		$o["table"]="spxwbookmarketkeyword";
		$o["out"]="array_asso";
		$tmp = $plxMotor->plxPlugins->aPlugins["spxdatas"];
		$akeyword = $tmp->getData($o);
		
		/*-2.2)------------bookmarket--------------------*/
		$o= array();
		$o["table"]="spxwbookmarket";
		$o["filter"]="actif=1";
		$o["out"]="array";
		$abookmarket = $tmp->getData($o);
		
		/*-2.3)------------check link--------------------*/
		foreach($abookmarket as $bookmarkets => $bookmarket) {
			$key = $bookmarket["keyword"];
			if ($key !=""){
				$akeyid = explode(' ', $key);
				foreach($akeyid as $keyids => $keyid) {
					$title = plxUtils::title2url($akeyword[$keyid]["title"]);
					$abookmarket[$bookmarkets]["keyword2"][$title]=$akeyword[$keyid];
				}
			}else{
				$abookmarket[$bookmarkets]["keyword2"]=false;
			}
		}
		
		/*-3)------------output html--------------------*/
		$format=$oatts["format"];
		$formattags=$oatts["formattags"];
		$s="";
		foreach($abookmarket as $bookmarkets => $bookmarket) {
			# $cible
			$name="";
			if ($cible=="" || $bookmarket["keyword2"][$cible]){
				$name = str_replace('#title',plxUtils::strCheck($bookmarket["title"]),$format);
				$name = str_replace('#content',$bookmarket["content"],$name);
				$name = str_replace('#date',$bookmarket["date"],$name);
				# tags
				$nametags="";
				if ($bookmarket["keyword2"]){
					foreach($bookmarket["keyword2"] as $keys => $key) {
						$title = $key["title"];
						$keytitle = plxUtils::title2url($key["title"]);
						
						if ($plxMotor->mode=='home'){
							$url = "?tagbookmarket/".$keytitle;
						}else{
							$url = "/tagbookmarket/".$keytitle;
						}
						
						$nametag = str_replace('#title',$title,$formattags);
						$nametag = str_replace('#url',$path_url.$url,$nametag);
						$nametags.=$nametag.$oatts["separatortags"];
					}
					# delete the last separator
					$nametags = substr($nametags, 0, -strlen($oatts["separatortags"]));
				}else{
					$nametags.=L_ARTTAGS_NONE;
				}
				
				
				
				$name = str_replace('#tags',$nametags,$name);
				$s.=$name;
			}
		}
		
		return $s;
	}
	
	/*
	 * Mthode qui permet de ne pas tenir compte des get bookmarket si en premire position
	 * 
	 * @return stdio
	 * @author: jevrard
	 */ 
	public function plxMotorPreChauffageBegin() {
		$string = "
			if(\$this->get && preg_match('/^tagbookmarket\/?/',\$this->get)) {
				\$this->get='';
				\$this->path_url='';
			}
		";
		echo "<?php ".$string." ?>";
	}
	
	# getloc call by spxdatas
	public function get_loc($mylang) {
		
		$filename = PLX_PLUGINS.$this->spxname.'/spxdatas/table/table_loc/'.$mylang.'/admin.php';
		$LANG = array();
		
		if(is_file($filename)) {
			include($filename);
		}
		return $LANG;
	}
	
	

}

?>